Index: META-INF/MANIFEST.MF
===================================================================
--- META-INF/MANIFEST.MF	(revision 33273)
+++ META-INF/MANIFEST.MF	(working copy)
@@ -27,7 +27,9 @@
 Export-Package: freemarker.core,
  freemarker.template,
  org.jboss.ide.eclipse.freemarker,
+ org.jboss.ide.eclipse.freemarker.contentassist,
  org.jboss.ide.eclipse.freemarker.editor,
+ org.jboss.ide.eclipse.freemarker.editor.editorpart,
  org.jboss.ide.eclipse.freemarker.model,
  org.jboss.ide.eclipse.freemarker.outline,
  org.jboss.ide.eclipse.freemarker.preferences
Index: src/org/jboss/ide/eclipse/freemarker/configuration/context/AbstractContextValue.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/configuration/context/AbstractContextValue.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/configuration/context/AbstractContextValue.java	(revision 0)
@@ -0,0 +1,45 @@
+package org.jboss.ide.eclipse.freemarker.configuration.context;
+
+/**
+ * 
+ * Abstract class for manage context value.
+ * 
+ * @version 1.0.4 
+ * @author <a href="mailto:angelo.zerr@gmail.com">Angelo ZERR</a>
+ *
+ */
+public abstract class AbstractContextValue implements IContextValue {
+
+	private String name;
+	private IObjectContext[] objectContexts;
+	
+	protected AbstractContextValue(String name) {
+		this.name = name;
+		this.objectContexts = new IObjectContext[2];
+	}
+	
+	public String getName() {
+		return this.name;
+	}
+	
+    public IObjectContext[] getContexts() {
+    	return objectContexts;
+    }
+    
+    protected void setFirstObjectContext(IObjectContext objectContext) {
+    	objectContexts[0] = objectContext;
+    }
+    
+    public IObjectContext getFirstObjectContext() {
+    	return this.objectContexts[0];
+    }
+    
+    public IObjectContext getSecondObjectContext() {
+    	return this.objectContexts[1];
+    }    
+    
+    protected void setSecondObjectContext(IObjectContext objectContext) {
+    	objectContexts[1] = objectContext;
+    }    
+	
+}
Index: src/org/jboss/ide/eclipse/freemarker/configuration/context/ClassContextValue.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/configuration/context/ClassContextValue.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/configuration/context/ClassContextValue.java	(revision 0)
@@ -0,0 +1,43 @@
+package org.jboss.ide.eclipse.freemarker.configuration.context;
+
+/**
+ * Class context value.
+ *  
+ * @version 1.0.4 
+ * @author <a href="mailto:angelo.zerr@gmail.com">Angelo ZERR</a>
+ *
+ */
+public class ClassContextValue extends AbstractContextValue {
+
+    public ClassContextValue(String name, Class objClass, Class singularClass)
+    {
+        super(name);
+        // Object class
+        setFirstObjectContext(new ClassObjectContext(objClass));
+        // Singular class
+        setSecondObjectContext(new ClassObjectContext(singularClass));
+    }
+    
+    public int getType() {
+    	return IContextValue.CLASS;
+    }
+	
+	public class ClassObjectContext implements IObjectContext {
+		
+		private Class objectClass;
+		
+		public ClassObjectContext(Class objectClass) {
+			this.objectClass = objectClass;
+		}
+		
+		public String getName() {
+	    	if (objectClass != null)
+	    		return objectClass.getName();
+	    	return null;
+		}
+		
+		public Object getObject() {
+			return this.objectClass;
+		}
+	}
+}
Index: src/org/jboss/ide/eclipse/freemarker/configuration/context/IContextValue.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/configuration/context/IContextValue.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/configuration/context/IContextValue.java	(revision 0)
@@ -0,0 +1,24 @@
+package org.jboss.ide.eclipse.freemarker.configuration.context;
+
+/**
+ * 
+ * Interface context value. 
+ * @version 1.0.0 
+ * @author <a href="mailto:angelo.zerr@gmail.com">Angelo ZERR</a>
+ *
+ */
+public interface IContextValue {
+
+	public final static int CLASS = 0;
+	public final static int STRING = 1;
+	public final static int XML = 2;
+	public final static int DTD = 3;
+	
+	public String getName();
+	public int getType();
+	public IObjectContext[] getContexts();
+	
+	public IObjectContext getFirstObjectContext();
+	public IObjectContext getSecondObjectContext();
+	
+}
Index: src/org/jboss/ide/eclipse/freemarker/configuration/context/IObjectContext.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/configuration/context/IObjectContext.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/configuration/context/IObjectContext.java	(revision 0)
@@ -0,0 +1,7 @@
+package org.jboss.ide.eclipse.freemarker.configuration.context;
+
+public interface IObjectContext {
+
+	public String getName();
+	public Object getObject();
+}
Index: src/org/jboss/ide/eclipse/freemarker/configuration/context/XMLContextValue.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/configuration/context/XMLContextValue.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/configuration/context/XMLContextValue.java	(revision 0)
@@ -0,0 +1,43 @@
+package org.jboss.ide.eclipse.freemarker.configuration.context;
+
+import org.w3c.dom.Document;
+
+/**
+ * XML context value
+ *  
+ * @version 1.0.0 
+ * @author <a href="mailto:angelo.zerr@gmail.com">Angelo ZERR</a>
+ *
+ */
+public class XMLContextValue extends AbstractContextValue  {
+	
+	
+	public XMLContextValue(String name, String xmlFile, Document document) {
+		super(name);
+		this.setFirstObjectContext(new XMLObjectContext(xmlFile, document));
+	}
+	
+	public int getType() {
+		return IContextValue.XML;
+	}
+	
+	public class XMLObjectContext implements IObjectContext {
+		
+		private String xmlFile;
+		private Document document;
+		
+		public XMLObjectContext(String xmlFile, Document document) {
+			this.xmlFile = xmlFile;
+			this.document = document;
+		}
+		
+		public String getName() {
+	    	return xmlFile;
+		}
+		
+		public Object getObject() {
+			return this.document;
+		}
+	}	
+	
+}
Index: src/org/jboss/ide/eclipse/freemarker/configuration/ConfigurationManager.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/configuration/ConfigurationManager.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/configuration/ConfigurationManager.java	(working copy)
@@ -46,6 +46,8 @@
 import org.eclipse.swt.widgets.Shell;
 import org.jboss.ide.eclipse.freemarker.Messages;
 import org.jboss.ide.eclipse.freemarker.Plugin;
+import org.jboss.ide.eclipse.freemarker.configuration.context.IContextValue;
+import org.jboss.ide.eclipse.freemarker.helper.ContextValueHelper;
 import org.w3c.dom.Document;
 import org.w3c.dom.Element;
 import org.w3c.dom.Node;
@@ -180,7 +182,7 @@
         return map;
 	}
 
-	private IFile getFile (String path) {
+	public IFile getFile (String path) {
 		return project.getFile(path);
 	}
 
@@ -195,6 +197,7 @@
                     .getElementsByTagName("resource"); //$NON-NLS-1$
             for (int i = 0; i < nl.getLength(); i++) {
                 try {
+                    IContextValue contextValue = null;
                     Node n = nl.item(i);
                     String path = ((Element) n).getAttribute("path"); //$NON-NLS-1$
                     List contextValues = new ArrayList();
@@ -202,21 +205,39 @@
                             .getElementsByTagName("value"); //$NON-NLS-1$
                     for (int j = 0; j < nl2.getLength(); j++) {
                         Node n2 = nl2.item(j);
-                        String key = ((Element) n2).getAttribute("key"); //$NON-NLS-1$
-                        Class value = getClass(((Element) n2)
-                                .getAttribute("object-class")); //$NON-NLS-1$
-                        String singularName = ((Element) n2)
-                                .getAttribute("item-class"); //$NON-NLS-1$
-                        Class singularClass = null;
-                        if (null != singularName && singularName.trim().length()>0)
-                            singularClass = getClass(singularName);
-                        contextValues.add(new ContextValue(key, value,
-                                singularClass));
+                        String key = ((Element) n2).getAttribute("key");
+                        // Instanciate Context value switch class/xml or string
+                        String className = ((Element)n2).getAttribute("object-class");
+                        if (className != null && className.trim().length() > 0) {  
+                            // Class context
+                            String singularName = ((Element)n2).getAttribute("item-class");
+                            contextValue = getInstanceOfContextValue(IContextValue.CLASS, key, className, singularName);
+                        }
+                        else {
+                            String stringValue = ((Element)n2).getAttribute("string-value");
+                            if (stringValue != null && stringValue.trim().length() > 0) {
+                                // String context
+                                contextValue = getInstanceOfContextValue(IContextValue.STRING, key, stringValue, null);                     
+                            }
+                            else {
+                                String xmlFile = ((Element)n2).getAttribute("xml-file");
+                                if (xmlFile != null && xmlFile.trim().length() > 0) {
+                                    // XML context
+                                    contextValue = getInstanceOfContextValue(IContextValue.XML, key, xmlFile, null);          
+                                }
+                                else {
+                                    String dtdFile = ((Element)n2).getAttribute("dtd-file");
+                                    if (dtdFile != null && dtdFile.trim().length() > 0) {
+                                        // DTD context
+                                        contextValue = getInstanceOfContextValue(IContextValue.DTD, key, dtdFile, null);          
+                                    }
+                                }
+                            }
+                        }
+                        if (contextValue != null) 
+                            contextValues.add(contextValue);
                     }
-                    map.put(path,
-                            contextValues
-                                    .toArray(new ContextValue[contextValues
-                                            .size()]));
+                    map.put(path, ((Object) (contextValues.toArray(new IContextValue[contextValues.size()]))));
                 } catch (Exception e) {
                 	Plugin.log(e);
                 }
@@ -301,28 +322,57 @@
         for (Iterator i = contextValues.entrySet().iterator(); i.hasNext();) {
             Map.Entry entry = (Map.Entry) i.next();
             String fileName = (String) entry.getKey();
-            ContextValue[] values = (ContextValue[]) entry.getValue();
+            IContextValue[] values = (IContextValue[]) entry.getValue();
             if (null != values && values.length > 0) {
-                sb.append("\t\t<resource path=\"" + fileName + "\">\n");  //$NON-NLS-1$//$NON-NLS-2$
+                sb.append("\t\t<resource path=\"" + fileName + "\">\n");
                 for (int j = 0; j < values.length; j++) {
-                    sb
-							.append("\t\t\t<value key=\"" + values[j].name //$NON-NLS-1$
-									+ "\" object-class=\"" + values[j].objClass.getName() //$NON-NLS-1$
-									+ "\""); //$NON-NLS-1$
-                    if (null != values[j].singularClass)
-                        sb.append(" item-class=\"" //$NON-NLS-1$
-								+ values[j].singularClass.getName() + "\""); //$NON-NLS-1$
-					sb.append("/>\n"); //$NON-NLS-1$
+                    // Manage context value for XML, String or class
+                    IContextValue contextValue = values[j];
+                    String key = contextValue.getName();
+                    if (contextValue.getType() == IContextValue.CLASS) {
+                        // Class context
+                        String objClassName = contextValue.getFirstObjectContext().getName();
+                        String singularClassName = contextValue.getSecondObjectContext().getName();
+                        sb.append("\t\t\t<value key=\"" +key + "\" object-class=\"" + objClassName + "\"");
+                        if(singularClassName != null)
+                            sb.append(" item-class=\"" +singularClassName + "\"");
+                        sb.append("/>\n");
+                    }
+                    else {
+                        if (contextValue.getType() == IContextValue.STRING) {
+                            // String context
+                            /*String stringValue = contextValue.getFirstObjectContext().getName();
+                            sb.append("\t\t\t<value key=\"" +  key + "\" string-value=\"" + stringValue + "\"");
+                            sb.append("/>\n");
+                            */                      
+                        }
+                        else {
+                            if (contextValue.getType() == IContextValue.XML) {
+                                // XML context
+                                String xmlFile = contextValue.getFirstObjectContext().getName();
+                                sb.append("\t\t\t<value key=\"" +  key + "\" xml-file=\"" + xmlFile + "\"");
+                                sb.append("/>\n"); 
+                            }
+                            else {
+                                /*if (contextValue.getType() == IContextValue.DTD) {
+                                    // XML context
+                                    String dtdFile = contextValue.getFirstObjectContext().getName();
+                                    sb.append("\t\t\t<value key=\"" +  key + "\" dtd-file=\"" + dtdFile + "\"");
+                                    sb.append("/>\n"); 
+                                }*/
+                            }
+                        }
+                    }
                 }
-                sb.append("\t\t</resource>\n"); //$NON-NLS-1$
+                sb.append("\t\t</resource>\n");
             }
         }
     }
     
-    public ContextValue[] getContextValues(IResource resource, boolean recurse) {
+    public IContextValue[] getContextValues(IResource resource, boolean recurse) {
         Map newValues = new HashMap();
         addRootContextValues(resource, newValues, recurse);
-        return (ContextValue[]) newValues.values().toArray(new ContextValue[newValues.size()]);
+        return (IContextValue[]) newValues.values().toArray(new IContextValue[newValues.size()]);
     }
     
     private void addRootContextValues(IResource resource, Map newValues, boolean recurse) {
@@ -334,29 +384,29 @@
         else
 			key = ""; //$NON-NLS-1$
         if (null != resource.getProject()) {
-	        ContextValue[] values = (ContextValue[]) contextValues.get(key);
+        	IContextValue[] values = (IContextValue[]) contextValues.get(key);
 	        if (null != values) {
 	            for (int i=0; i<values.length; i++) {
-	                newValues.put(values[i].name, values[i]);
+	                newValues.put(values[i].getName(), values[i]);
 	            }
 	        }
         }
     }
 
-    public ContextValue getContextValue(String name, IResource resource, boolean recurse) {
-        ContextValue[] values = getContextValues(resource, recurse);
+    public IContextValue getContextValue(String name, IResource resource, boolean recurse) {
+    	IContextValue[] values = getContextValues(resource, recurse);
         for (int i = 0; i < values.length; i++) {
-            if (values[i].name.equals(name))
+            if (values[i].getName().equals(name))
                 return values[i];
         }
         return null;
     }
 
-    public void addContextValue(ContextValue contextValue, IResource resource) {
-        ContextValue[] contextValues = getContextValues(resource, false);
+    public void addContextValue(IContextValue contextValue, IResource resource) {
+        IContextValue[] contextValues = getContextValues(resource, false);
         boolean found = false;
         for (int i = 0; i < contextValues.length; i++) {
-            if (contextValues[i].name.equals(contextValue.name)) {
+            if (contextValues[i].getName().equals(contextValue.getName())) {
                 found = true;
                 contextValues[i] = contextValue;
                 this.contextValues.put(
@@ -366,7 +416,7 @@
             }
         }
         if (!found) {
-            ContextValue[] newContextValues = new ContextValue[contextValues.length + 1];
+            IContextValue[] newContextValues = new IContextValue[contextValues.length + 1];
             int index = 0;
             while (index < contextValues.length) {
                 newContextValues[index] = contextValues[index++];
@@ -377,21 +427,21 @@
         save();
     }
 
-    public void updateContextValue(ContextValue contextValue, IFile file) {
+    public void updateContextValue(IContextValue contextValue, IFile file) {
         addContextValue(contextValue, file);
     }
 
     public void removeContextValue(String name, IResource resource) {
-        ContextValue[] values = getContextValues(resource, false);
+        IContextValue[] values = getContextValues(resource, false);
         int index = -1;
         for (int i = 0; i < values.length; i++) {
-            if (values[i].name.equals(name)) {
+            if (values[i].getName().equals(name)) {
                 index = i;
                 break;
             }
         }
         if (index >= 0) {
-            ContextValue[] newValues = new ContextValue[values.length - 1];
+            IContextValue[] newValues = new IContextValue[values.length - 1];
             int j = 0;
             for (int i = 0; i < values.length; i++) {
                 if (i != index)
@@ -401,4 +451,21 @@
             save();
         }
     }
+    
+    /**
+     * Return an instance of context value swith contextType (CLASS, XML, ...)
+     * @param contextType
+     * @param name
+     * @param context1
+     * @param context2
+     * @return
+     * @throws Exception
+     */
+    public IContextValue getInstanceOfContextValue(int contextType,  String name, 
+            String context1, String context2) throws Exception
+    {
+        return ContextValueHelper.getInstanceOfContextValue(this, contextType, name, context1,
+                context2);
+    }
+    
 }
\ No newline at end of file
